execute as @e[tag=zombie,type=zombie] run data merge entity @s {Health:1024}

execute as @e[name=Candyman,type=villager] at @s run teleport @s ~ ~ ~ facing entity @p[scores={minigames=1..}] eyes

#spectate
execute if entity @e[tag=controller,type=armor_stand,tag=specMode] as @a[scores={player=1..},gamemode=spectator] at @s run spectate @p[scores={minigames=1..,player=1..}] @s

#start
execute as @e[tag=controller,type=armor_stand,tag=playingMinigame1] run scoreboard players add @s minigameTime 1

execute as @e[tag=controller,type=armor_stand,scores={minigameTime=1..}] run title @a[scores={minigames=1..}] times 0 20 0 
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=1..20}] run title @a[scores={minigames=1..}] title [{"text":"3","color":"red"}]
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=1}] as @a[scores={minigames=1..}] at @s run playsound block.note_block.chime master @s ~ ~ ~ 1000
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=21..40}] run title @a[scores={minigames=1..}] title [{"text":"2","color":"yellow"}]
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=21}] as @a[scores={minigames=1..}] at @s run playsound block.note_block.chime master @s ~ ~ ~ 1000
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=41..60}] run title @a[scores={minigames=1..}] title [{"text":"1","color":"green"}]
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=41}] as @a[scores={minigames=1..}] at @s run playsound block.note_block.chime master @s ~ ~ ~ 1000
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61}] run title @a[scores={minigames=1..}] title [{"text":""}]
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61}] as @a[scores={minigames=1..}] at @s run playsound entity.generic.explode master @s ~ ~ ~ 1000

#timer
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..}] run scoreboard players add @s timerD1 1
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..,timerD1=20}] run scoreboard players remove @s timerD2 1
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..,timerD1=20,timerD2=-1}] run scoreboard players remove @s timerD3 1
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..,timerD1=20,timerD2=-1}] run scoreboard players set @s timerD2 59
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..,timerD1=20}] run scoreboard players reset * timerD1

execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..,timerD2=0..9}] run title @a actionbar [{"score":{"name":"@e[tag=controller,type=armor_stand]","objective":"timerD3"},"color":"dark_purple","bold":"false"},{"text":":","color":"dark_purple","bold":"false"},{"text":"0","color":"dark_purple","bold":"false"},{"score":{"name":"@e[tag=controller]","objective":"timerD2"},"color":"dark_purple","bold":"false"}]
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61..,timerD2=10..}] run title @a actionbar [{"score":{"name":"@e[tag=controller,type=armor_stand]","objective":"timerD3"},"color":"dark_purple","bold":"false"},{"text":":","color":"dark_purple","bold":"false"},{"score":{"name":"@e[tag=controller]","objective":"timerD2"},"color":"dark_purple","bold":"false"}]

#mechanics
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61}] as @a[scores={minigames=1..}] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.25},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=61}] as @a[scores={minigames=1..},limit=1] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.26},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=261}] as @a[scores={minigames=1..}] at @e[tag=zSpawn,type=area_effect_cloud,sort=nearest,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.27},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=261}] as @a[scores={minigames=1..},limit=1] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.28},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=461}] as @a[scores={minigames=1..}] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.29},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=461}] as @a[scores={minigames=1..},limit=1] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.30},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=661}] as @a[scores={minigames=1..}] at @e[tag=zSpawn,type=area_effect_cloud,sort=nearest,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.31},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=661}] as @a[scores={minigames=1..},limit=1] at @e[tag=zSpawn,type=area_effect_cloud,sort=nearest,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.32},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=861}] as @a[scores={minigames=1..}] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.33},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=861}] as @a[scores={minigames=1..},limit=1] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.34},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=1061}] as @a[scores={minigames=1..}] at @e[tag=zSpawn,type=area_effect_cloud,sort=nearest,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.35},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}
execute as @e[tag=controller,type=armor_stand,scores={minigameTime=1061}] as @a[scores={minigames=1..},limit=1] at @e[tag=zSpawn,type=area_effect_cloud,sort=random,limit=1] run summon zombie ~ ~-0.5 ~ {Invulnerable:0,Health:1024.0,PersistenceRequired:1,Attributes:[{Name:generic.attackDamage,Base:0.1},{Name:generic.movementSpeed,Base:0.36},{Name:generic.knockbackResistance,Base:0.5},{Name:generic.followRange,Base:50.0},{Name:generic.maxHealth,Base:1024.0},{Name:zombie.spawnReinforcements,Base:0.0}],Tags:["zombie"]}

#eliminated
execute as @a[scores={minigames=1..,hitByZombie=1..}] run scoreboard players set @s leave 1
execute as @a[scores={minigames=1..,hitByZombie=1..}] run gamemode spectator @s
execute as @a[scores={minigames=1..,hitByZombie2=1..}] run scoreboard players set @s leave 1
execute as @a[scores={minigames=1..,hitByZombie2=1..}] run gamemode spectator @s

#lose
execute unless entity @a[scores={minigames=1..}] run function single:minigame1end

#won
execute as @e[tag=controller,type=armor_stand,scores={timerD3=0,timerD2=0}] run tag @e[tag=controller,type=armor_stand] add won
execute as @e[tag=controller,type=armor_stand,scores={timerD3=0,timerD2=0}] run function single:minigame1end